"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enumerable_1 = require("../enumerable");
var utils_1 = require("../utils");
var exceptions_1 = require("../exceptions");
function average(source, selector) {
    var e_1, _a;
    utils_1.throws.ThrowIfNull('source', source);
    if (!enumerable_1.Enumerable.Any(source)) {
        return null;
    }
    selector =
        selector ||
            (function (x) {
                if (utils_1.IsNullOrUndefined(x)) {
                    return null;
                }
                if (typeof x === 'number') {
                    return x;
                }
                else {
                    throw new exceptions_1.ArgumentNullException('selector', '数值类型以外的数组必须传入 selector');
                }
            });
    var sum = 0;
    var count = 0;
    var allNull = true;
    try {
        for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
            var item = source_1_1.value;
            var value = selector(item);
            if (!utils_1.IsNullOrUndefined(value)) {
                allNull = false;
                sum += value;
            }
            count++;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (allNull) {
        return null;
    }
    return sum / count;
}
exports.average = average;
//# sourceMappingURL=average.js.map