"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var enumerable_1 = require("./enumerable");
var Grouping = /** @class */ (function () {
    function Grouping(key, source) {
        this.key = key;
        this.source = source;
    }
    Object.defineProperty(Grouping.prototype, "Key", {
        get: function () {
            return this.key;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Grouping.prototype, "Items", {
        get: function () {
            return this.source;
        },
        enumerable: true,
        configurable: true
    });
    Grouping.prototype[Symbol.iterator] = function () {
        return this.source[Symbol.iterator]();
    };
    Grouping.prototype.All = function (predicate) {
        return enumerable_1.Enumerable.All(this, predicate);
    };
    Grouping.prototype.Any = function (predicate) {
        return enumerable_1.Enumerable.Any(this, predicate);
    };
    Grouping.prototype.AsEnumerable = function () {
        return enumerable_1.Enumerable.AsEnumerable(this.source);
    };
    Grouping.prototype.Average = function (selector) {
        return enumerable_1.Enumerable.Average(this, selector);
    };
    Grouping.prototype.Concat = function (second) {
        return enumerable_1.Enumerable.Concat(this, second);
    };
    Grouping.prototype.Contains = function (value, comparer) {
        return enumerable_1.Enumerable.Contains(this, value, comparer);
    };
    Grouping.prototype.Count = function (predicate) {
        return enumerable_1.Enumerable.Count(this, predicate);
    };
    Grouping.prototype.DefaultIfEmpty = function (defaultValue) {
        return enumerable_1.Enumerable.DefaultIfEmpty(this, defaultValue);
    };
    Grouping.prototype.Distinct = function (comparer) {
        return enumerable_1.Enumerable.Distinct(this, comparer);
    };
    Grouping.prototype.ElementAt = function (index) {
        return enumerable_1.Enumerable.ElementAt(this, index);
    };
    Grouping.prototype.ElementAtOrDefault = function (defaultValue, index) {
        return enumerable_1.Enumerable.ElementAtOrDefault(this, defaultValue, index);
    };
    Grouping.prototype.Except = function (second, comparer) {
        return enumerable_1.Enumerable.Except(this, second, comparer);
    };
    Grouping.prototype.First = function (predicate) {
        return enumerable_1.Enumerable.First(this, predicate);
    };
    Grouping.prototype.FirstOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.FirstOrDefault(this, defaultValue, predicate);
    };
    Grouping.prototype.GroupBy = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.GroupBy(this, keySelector, elementSelector, comparer);
    };
    Grouping.prototype.GroupJoin = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.GroupJoin(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    Grouping.prototype.Intersect = function (second, comparer) {
        return enumerable_1.Enumerable.Intersect(this, second, comparer);
    };
    Grouping.prototype.Join = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.Join(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    Grouping.prototype.Last = function (predicate) {
        return enumerable_1.Enumerable.Last(this, predicate);
    };
    Grouping.prototype.LastOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.LastOrDefault(this, defaultValue, predicate);
    };
    Grouping.prototype.Max = function (selector) {
        return enumerable_1.Enumerable.Max(this, selector);
    };
    Grouping.prototype.Min = function (selector) {
        return enumerable_1.Enumerable.Min(this, selector);
    };
    Grouping.prototype.Reverse = function () {
        return enumerable_1.Enumerable.Reverse(this);
    };
    Grouping.prototype.Select = function (selector) {
        return enumerable_1.Enumerable.Select(this, selector);
    };
    Grouping.prototype.SelectMany = function (collectionSelector, resultSelector) {
        return enumerable_1.Enumerable.SelectMany(this, collectionSelector, resultSelector);
    };
    Grouping.prototype.SequenceEqual = function (second, comparer) {
        return enumerable_1.Enumerable.SequenceEqual(this, second, comparer);
    };
    Grouping.prototype.Single = function (predicate) {
        return enumerable_1.Enumerable.Single(this, predicate);
    };
    Grouping.prototype.SingleOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.SingleOrDefault(this, defaultValue, predicate);
    };
    Grouping.prototype.Skip = function (count) {
        return enumerable_1.Enumerable.Skip(this, count);
    };
    Grouping.prototype.SkipWhile = function (predicate) {
        return enumerable_1.Enumerable.SkipWhile(this, predicate);
    };
    Grouping.prototype.Sum = function (selector) {
        return enumerable_1.Enumerable.Sum(this, selector);
    };
    Grouping.prototype.Take = function (count) {
        return enumerable_1.Enumerable.Take(this, count);
    };
    Grouping.prototype.TakeWhile = function (predicate) {
        return enumerable_1.Enumerable.TakeWhile(this, predicate);
    };
    Grouping.prototype.ToArray = function () {
        return enumerable_1.Enumerable.ToArray(this);
    };
    Grouping.prototype.ToDictionary = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.ToDictionary(this, keySelector, elementSelector, comparer);
    };
    Grouping.prototype.ToList = function () {
        return enumerable_1.Enumerable.ToList(this);
    };
    Grouping.prototype.Union = function (second, comparer) {
        return enumerable_1.Enumerable.Union(this, second, comparer);
    };
    Grouping.prototype.Where = function (predicate) {
        return enumerable_1.Enumerable.Where(this, predicate);
    };
    return Grouping;
}());
exports.Grouping = Grouping;
//# sourceMappingURL=grouping.js.map