"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enumerable_1 = require("./enumerable");
var exceptions_1 = require("./exceptions");
var read_only_collection_1 = require("./read-only-collection");
var utils_1 = require("./utils");
var List = /** @class */ (function () {
    function List(collection) {
        this.items = [];
        if (collection) {
            if (collection instanceof Array) {
                this.items = collection.map(function (x) { return x; });
            }
            else {
                this.AddRange(collection);
            }
        }
    }
    Object.defineProperty(List.prototype, "Length", {
        get: function () {
            return this.items.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(List.prototype, "IsReadOnly", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    List.prototype.Set = function (index, item) {
        if (index < 0 || index >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('index', index);
        }
        this.items[index] = item;
    };
    List.prototype.Get = function (index) {
        if (index < 0 || index >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('index', index);
        }
        return this.items[index];
    };
    List.prototype.Add = function (item) {
        this.items.push(item);
    };
    List.prototype.AddRange = function (collection) {
        var e_1, _a;
        if (collection) {
            try {
                for (var collection_1 = __values(collection), collection_1_1 = collection_1.next(); !collection_1_1.done; collection_1_1 = collection_1.next()) {
                    var item = collection_1_1.value;
                    this.Add(item);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (collection_1_1 && !collection_1_1.done && (_a = collection_1.return)) _a.call(collection_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    List.prototype.AsReadOnly = function () {
        return new read_only_collection_1.ReadOnlyCollection(this);
    };
    List.prototype.Clear = function () {
        this.items = [];
    };
    List.prototype.CopyTo = function (array, arrayIndex) {
        var e_2, _a;
        var i = 0;
        try {
            for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
                var item = _c.value;
                array[i++ + arrayIndex] = item;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    List.prototype.Exists = function (match) {
        utils_1.throws.ThrowIfNull('match', match);
        return this.Any(match);
    };
    List.prototype.Find = function (match) {
        utils_1.throws.ThrowIfNull('match', match);
        return this.FirstOrDefault(null, match);
    };
    List.prototype.FindAll = function (match) {
        utils_1.throws.ThrowIfNull('match', match);
        return this.Where(match).ToList();
    };
    List.prototype.FindIndex = function (startIndex, count, match) {
        if (startIndex < 0 || startIndex >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('startIndex', startIndex);
        }
        if (count < 0 || count > this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('count', count);
        }
        if (startIndex + count > this.Length) {
            throw new exceptions_1.ArgumentException('startIndex + count');
        }
        utils_1.throws.ThrowIfNull('match', match);
        var length = this.items.length;
        var times = 0;
        for (var i = startIndex; i < length; i++) {
            if (++times > count) {
                break;
            }
            if (match(this.items[i])) {
                return i;
            }
        }
        return -1;
    };
    List.prototype.FindLast = function (match) {
        utils_1.throws.ThrowIfNull('match', match);
        return this.LastOrDefault(null, match);
    };
    List.prototype.FindLastIndex = function (startIndex, count, match) {
        if (startIndex < 0 || startIndex >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('startIndex', startIndex);
        }
        if (count < 0 || count > this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('count', count);
        }
        if (startIndex + count > this.Length) {
            throw new exceptions_1.ArgumentException('startIndex + count');
        }
        utils_1.throws.ThrowIfNull('match', match);
        var times = 0;
        for (var i = startIndex; i >= 0; i--) {
            if (++times > count) {
                break;
            }
            if (match(this.items[i])) {
                return i;
            }
        }
        return -1;
    };
    List.prototype.GetRange = function (index, count) {
        if (index < 0 || index >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('index', index);
        }
        if (count < 0 || count > this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('count', count);
        }
        if (index + count > this.Length) {
            throw new exceptions_1.ArgumentException('index + count');
        }
        return new List(range(this.items, index, count));
    };
    List.prototype.IndexOf = function (item) {
        return this.items.findIndex(function (x) { return x === item; });
    };
    List.prototype.Insert = function (index, item) {
        if (index < 0 || index >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('index', index);
        }
        this.items.splice(index, 0, item);
    };
    List.prototype.Remove = function (item) {
        var index = this.IndexOf(item);
        if (index >= 0) {
            this.RemoveAt(index);
            return true;
        }
        return false;
    };
    List.prototype.RemoveAt = function (index) {
        if (index < 0 || index >= this.Length) {
            throw new exceptions_1.ArgumentOutOfRangeException('index', index);
        }
        this.items.splice(index, 1);
    };
    List.prototype.TrueForAll = function (match) {
        utils_1.throws.ThrowIfNull('match', match);
        return this.All(match);
    };
    List.prototype[Symbol.iterator] = function () {
        var e_3, _a, _b, _c, item, e_3_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 5, 6, 7]);
                    _b = __values(this.items), _c = _b.next();
                    _d.label = 1;
                case 1:
                    if (!!_c.done) return [3 /*break*/, 4];
                    item = _c.value;
                    return [4 /*yield*/, item];
                case 2:
                    _d.sent();
                    _d.label = 3;
                case 3:
                    _c = _b.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_3_1 = _d.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    List.prototype.All = function (predicate) {
        return enumerable_1.Enumerable.All(this, predicate);
    };
    List.prototype.Any = function (predicate) {
        return enumerable_1.Enumerable.Any(this, predicate);
    };
    List.prototype.AsEnumerable = function () {
        return enumerable_1.Enumerable.AsEnumerable(this);
    };
    List.prototype.Average = function (selector) {
        return enumerable_1.Enumerable.Average(this, selector);
    };
    List.prototype.Concat = function (second) {
        return enumerable_1.Enumerable.Concat(this, second);
    };
    List.prototype.Contains = function (value, comparer) {
        return enumerable_1.Enumerable.Contains(this, value, comparer);
    };
    List.prototype.Count = function (predicate) {
        return enumerable_1.Enumerable.Count(this, predicate);
    };
    List.prototype.DefaultIfEmpty = function (defaultValue) {
        return enumerable_1.Enumerable.DefaultIfEmpty(this, defaultValue);
    };
    List.prototype.Distinct = function (comparer) {
        return enumerable_1.Enumerable.Distinct(this, comparer);
    };
    List.prototype.ElementAt = function (index) {
        return enumerable_1.Enumerable.ElementAt(this, index);
    };
    List.prototype.ElementAtOrDefault = function (defaultValue, index) {
        return enumerable_1.Enumerable.ElementAtOrDefault(this, defaultValue, index);
    };
    List.prototype.Except = function (second, comparer) {
        return enumerable_1.Enumerable.Except(this, second, comparer);
    };
    List.prototype.First = function (predicate) {
        return enumerable_1.Enumerable.First(this, predicate);
    };
    List.prototype.FirstOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.FirstOrDefault(this, defaultValue, predicate);
    };
    List.prototype.GroupBy = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.GroupBy(this, keySelector, elementSelector, comparer);
    };
    List.prototype.GroupJoin = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.GroupJoin(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    List.prototype.Intersect = function (second, comparer) {
        return enumerable_1.Enumerable.Intersect(this, second, comparer);
    };
    List.prototype.Join = function (inner, outerKeySelector, innerKeySelector, resultSelector, comparer) {
        return enumerable_1.Enumerable.Join(this, inner, outerKeySelector, innerKeySelector, resultSelector, comparer);
    };
    List.prototype.Last = function (predicate) {
        return enumerable_1.Enumerable.Last(this, predicate);
    };
    List.prototype.LastOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.LastOrDefault(this, defaultValue, predicate);
    };
    List.prototype.Max = function (selector) {
        return enumerable_1.Enumerable.Max(this, selector);
    };
    List.prototype.Min = function (selector) {
        return enumerable_1.Enumerable.Min(this, selector);
    };
    List.prototype.Reverse = function () {
        return enumerable_1.Enumerable.Reverse(this);
    };
    List.prototype.Select = function (selector) {
        return enumerable_1.Enumerable.Select(this, selector);
    };
    List.prototype.SelectMany = function (collectionSelector, resultSelector) {
        return enumerable_1.Enumerable.SelectMany(this, collectionSelector, resultSelector);
    };
    List.prototype.SequenceEqual = function (second, comparer) {
        return enumerable_1.Enumerable.SequenceEqual(this, second, comparer);
    };
    List.prototype.Single = function (predicate) {
        return enumerable_1.Enumerable.Single(this, predicate);
    };
    List.prototype.SingleOrDefault = function (defaultValue, predicate) {
        return enumerable_1.Enumerable.SingleOrDefault(this, defaultValue, predicate);
    };
    List.prototype.Skip = function (count) {
        return enumerable_1.Enumerable.Skip(this, count);
    };
    List.prototype.SkipWhile = function (predicate) {
        return enumerable_1.Enumerable.SkipWhile(this, predicate);
    };
    List.prototype.Sum = function (selector) {
        return enumerable_1.Enumerable.Sum(this, selector);
    };
    List.prototype.Take = function (count) {
        return enumerable_1.Enumerable.Take(this, count);
    };
    List.prototype.TakeWhile = function (predicate) {
        return enumerable_1.Enumerable.TakeWhile(this, predicate);
    };
    List.prototype.ToArray = function () {
        return enumerable_1.Enumerable.ToArray(this);
    };
    List.prototype.ToDictionary = function (keySelector, elementSelector, comparer) {
        return enumerable_1.Enumerable.ToDictionary(this, keySelector, elementSelector, comparer);
    };
    List.prototype.ToList = function () {
        return enumerable_1.Enumerable.ToList(this);
    };
    List.prototype.Union = function (second, comparer) {
        return enumerable_1.Enumerable.Union(this, second, comparer);
    };
    List.prototype.Where = function (predicate) {
        return enumerable_1.Enumerable.Where(this, predicate);
    };
    return List;
}());
exports.List = List;
function range(array, index, count) {
    var length, c, i;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                length = array.length;
                c = 0;
                i = index;
                _a.label = 1;
            case 1:
                if (!(i < length)) return [3 /*break*/, 4];
                if (++c > count) {
                    return [3 /*break*/, 4];
                }
                return [4 /*yield*/, array[i]];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/];
        }
    });
}
//# sourceMappingURL=list.js.map